summaryrefslogtreecommitdiffstats
path: root/lib/cmd/opkg.sh
diff options
context:
space:
mode:
authorP. J. McDermott <pj@pehjota.net>2014-08-27 22:25:15 (EDT)
committer P. J. McDermott <pj@pehjota.net>2014-08-27 22:25:15 (EDT)
commit26aa1c83c76e72d9ed472e7dd4fbe2ad041a774c (patch)
treec110b34d2a5859b634f12d4ddbcd14a42fceac9a /lib/cmd/opkg.sh
parentfd9be223b3a6959d7936cb2c8ed7855ec03d53c1 (diff)
opkg: New command
Diffstat (limited to 'lib/cmd/opkg.sh')
-rw-r--r--lib/cmd/opkg.sh79
1 files changed, 79 insertions, 0 deletions
diff --git a/lib/cmd/opkg.sh b/lib/cmd/opkg.sh
new file mode 100644
index 0000000..e415387
--- /dev/null
+++ b/lib/cmd/opkg.sh
@@ -0,0 +1,79 @@
+# "opkg" command
+#
+# Copyright (C) 2014 Patrick "P. J." McDermott
+#
+# This file is part of the ProteanOS Development Kit.
+#
+# The ProteanOS Development Kit is free software: you can redistribute
+# it and/or modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# The ProteanOS Development Kit is distributed in the hope that it
+# will be useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+# See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with the ProteanOS Development Kit. If not, see
+# <http://www.gnu.org/licenses/>.
+
+use profile
+use chroot
+use rand
+
+cmd_opkg_main()
+{
+ local root=
+ local first_arg=
+ local install_cmd=
+ local opks=
+ local arg=
+ local new_fname=
+
+ if [ ${#} -lt 1 ]; then
+ print_cmd_usage 'opkg' >&2
+ exit 1
+ fi
+
+ root="${1}"
+ shift 1
+
+ first_arg=true
+ install_cmd=false
+ opks=''
+ for arg in "${@}"; do
+ if ${first_arg}; then
+ set --
+ first_arg=false
+ fi
+ if ${install_cmd}; then
+ case "${arg}" in
+ *.opk|*.ipk|*.deb)
+ rand
+ new_fname="/tmp/prokit.${rand_x}.opk"
+ opks="${opks} ${new_fname}"
+ cp "${arg}" "${root}${new_fname}"
+ set -- "${@}" "${new_fname}"
+ ;;
+ *)
+ set -- "${@}" "${arg}"
+ ;;
+ esac
+ else
+ set -- "${@}" "${arg}"
+ if [ "x${arg}" = 'xinstall' ]; then
+ install_cmd=true
+ fi
+ fi
+ done
+
+ . "${root}/etc/os-release"
+ profile_set "${ID}"
+
+ chroot_exec "${root}" opkg "${@}"
+
+ for new_fname in ${opks}; do
+ rm -f "${root}${new_fname}"
+ done
+}